/**
 * Your Copyright Here
 *
 * Appcelerator Titanium is Copyright (c) 2009-2010 by Appcelerator, Inc.
 * and licensed under the Apache Public License (version 2)
 */
#import "EkModule.h"
#import "TiBase.h"
#import "TiHost.h"
#import "TiUtils.h"
#import <EventKit/EventKit.h>

@implementation EkModule

#pragma mark Lifecycle

-(void)startup
{
	[super startup];
	NSLog(@"[INFO] %@ loaded",self);
}

-(void)shutdown:(id)sender
{
	[super shutdown:sender];
}

#pragma mark Cleanup 

-(void)dealloc
{
	[super dealloc];
}

#pragma mark Internal Memory Management

-(void)didReceiveMemoryWarning:(NSNotification*)notification
{
	[super didReceiveMemoryWarning:notification];
}

#pragma mark Listener Notifications

-(void)_listenerAdded:(NSString *)type count:(int)count
{
	if (count == 1 && [type isEqualToString:@"my_event"])
	{
	}
}

-(void)_listenerRemoved:(NSString *)type count:(int)count
{
	if (count == 0 && [type isEqualToString:@"my_event"])
	{
	}
}

#pragma Public APIs

-(id)newevent:(id)args
{
	id arg1 = [args objectAtIndex:0];  // Start Date
	id arg2 = [args objectAtIndex:1];  // End Date
	id arg3 = [args objectAtIndex:2];  // Title
	id arg4 = [args objectAtIndex:3];  // Location
	id arg5 = [args objectAtIndex:4];  // Text
	
	NSDateFormatter *df = [[NSDateFormatter alloc] init];
	[df setDateFormat:@"yyyy-MM-dd hh:mm:ss"];
	NSDate *startdate = [df dateFromString: arg1];
	NSDate *enddate = [df dateFromString: arg2];
	
	EKEventStore *eventStore = [[[EKEventStore alloc] init] autorelease];
	
	EKEvent *event  = [EKEvent eventWithEventStore:eventStore];
	
	event.title     = arg3;
	event.location  = arg4;
	event.notes     = arg5;
	event.startDate = startdate;
	event.endDate   = enddate;
	
	[event setCalendar:[eventStore defaultCalendarForNewEvents]];
	NSError *err;
	[eventStore saveEvent:event span:EKSpanThisEvent error:&err];
	
	return event.eventIdentifier;
}

-(id)getevent:(id)args
{
	id arg1 = [args objectAtIndex:0];  // Event Identifier
	
	EKEventStore *eventStore = [[[EKEventStore alloc] init] autorelease];

	EKEvent *event  = [eventStore eventWithIdentifier:arg1];

	NSArray  *eventvals = [NSArray arrayWithObjects:event.startDate, event.endDate, event.title, event.location, event.notes, nil];

	return eventvals;
}
@end
